<?php

namespace RxConnexionBundle\Form;

use Doctrine\Common\Persistence\ObjectManager;
use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\Mapping\Entity;
use RxConnexionBundle\Form\DataTransformer\DataTransformer;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\OptionsResolver\OptionsResolver;
use RxConnexionBundle\Entity\CanvassItemEntity;
use RxConnexionBundle\Entity\CanvassItemSupplierEntity;

class CanvassItemSupplierForm extends AbstractType
{
    private $manager;

    public function __construct(ObjectManager $manager) {
        $this->manager = $manager;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('action', HiddenType::class, array(
                'mapped' => false,
                'attr' => array(
                    'class' => 'form-action'
                )
            ))
            ->add('canvassItem', HiddenType::class, array(
                'mapped' => false,
                'data' => $options['canvassItem_id']
            ))
            ->add('id', HiddenType::class)
            ->add('created_by', HiddenType::class)
            ->add('created_at', HiddenType::class)
            ->add('updated_by', HiddenType::class)
            ->add('updated_at', HiddenType::class)
            ->add('price', TextType::class, array(
                'label' => 'Price',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => false,
                'attr' => array(
                    'class' => 'amount'
                )
            ))
            ->add('note', TextType::class, array(
                'label' => 'Notes',
                'label_attr' => array(
                    'class' => 'middle'
                ),
                'required' => false
            ))
            ->add('supplier', HiddenType::class)
            ->addEventListener(FormEvents::PRE_SET_DATA, function(FormEvent $event) {

                $form = $event->getForm();
                $data = $event->getData();
                $bank = $data->getSupplier();

                $form
                    ->add('supplier_description', TextType::class, array(
                        'mapped' => false,
                        'label' => 'Supplier',
                        'label_attr' => array(
                            'class' => 'middle'
                        ),
                        'required' => false,
                        'data' => $bank ? $bank->getDescription() : ''
                    ));
            });
        $builder->get('supplier')->addModelTransformer(new DataTransformer($this->manager, 'RxConnexionBundle:SupplierEntity', false));;
    }

    public function getName()
    {
        return 'canvassItemSupplier';
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(array(
            'data_class' 	  => 'RxConnexionBundle\Entity\CanvassItemSupplierEntity',
            'csrf_protection' => true,
            'csrf_field_name' => '_token',
            // a unique key to help generate the secret token
            'intention'       => 'canvassItemSupplierEntity_intention',
            'action'          => 'n',
            'canvassItem_id'          => null
        ));
    }
}